﻿Imports System.IO
Imports System.Xml

Module Module1

    Dim n As Integer
    Dim podatki(,) As String
    Dim povrsina As Single

    Const PODATEK_KO As Integer = 1
    Const PODATEK_OZNAKA As Integer = 2
    Const PODATEK_POVRSINA As Integer = 3

    Sub Main()

        Console.WriteLine("Parcela v0.1")
        Console.WriteLine("-------------------------")
        Console.WriteLine()

        ' VnosPodatkov()
        ' VnosPodatkovIzDatoteke()
        VnosPodatkovIzXmlDatoteke()
        Izracun()
        Izpis()

    End Sub

    Sub VnosPodatkovIzXmlDatoteke()
        Dim xmlDoc As New XmlDocument
        xmlDoc.Load("primer.xml")

        Dim xmlPodatki As XmlElement = xmlDoc.DocumentElement()

        Dim xmlParcele As XmlElement = xmlPodatki.SelectSingleNode("parcele")
        Dim xmlParceleList As XmlNodeList = xmlParcele.SelectNodes("parcela")

        n = xmlParceleList.Count
        ReDim podatki(n, 3)

        Dim i As Integer
        For Each xmlParcela As XmlNode In xmlParceleList
            i = i + 1

            podatki(i, PODATEK_KO) = xmlParcela.Attributes.GetNamedItem("ko").Value
            podatki(i, PODATEK_OZNAKA) = xmlParcela.Attributes.GetNamedItem("oznaka").Value

            Dim xmlPovrsina As XmlElement = xmlParcela.SelectSingleNode("povrsina")
            podatki(i, PODATEK_POVRSINA) = xmlPovrsina.InnerText
        Next

    End Sub

    Sub VnosPodatkovIzDatoteke()
        Dim dat As StreamReader
        dat = New StreamReader("primer.txt")

        n = dat.ReadLine()

        ReDim podatki(n, 3)

        For i As Integer = 1 To n
            Dim vrstica As String = dat.ReadLine()
            Dim besede() As String = vrstica.Split()

            podatki(i, PODATEK_KO) = besede(0)
            podatki(i, PODATEK_OZNAKA) = besede(1)
            podatki(i, PODATEK_POVRSINA) = besede(2)
        Next
    End Sub

    Sub VnosPodatkov()
        Console.WriteLine()
        Console.WriteLine("----- Vnos podatkov")
        Console.Write("Podaj število parcel: ")
        n = Console.ReadLine()

        ReDim podatki(n, 3)

        Console.WriteLine("Vnos podatkov za parcele (KO OZNAKA POVRŠINA). ")
        For i As Integer = 1 To n
            Console.Write("Parcela {0}: ", i)
            Dim vrstica As String = Console.ReadLine()
            Dim besede() As String = vrstica.Split()

            podatki(i, PODATEK_KO) = besede(0)
            podatki(i, PODATEK_OZNAKA) = besede(1)
            podatki(i, PODATEK_POVRSINA) = besede(2)
        Next
    End Sub

    Sub Izracun()
        For i As Integer = 1 To n
            povrsina = povrsina + podatki(i, PODATEK_POVRSINA)
        Next
    End Sub

    Sub Izpis()
        IzpisNaZaslon()
        IzpisVXmlDatoteko()
    End Sub

    Sub IzpisVXmlDatoteko()
        Dim xmlDoc As New XmlDocument

        Dim xmlDec As XmlDeclaration = xmlDoc.CreateXmlDeclaration("1.0", "UTF-8", Nothing)
        xmlDoc.AppendChild(xmlDec)

        Dim xmlPodatki As XmlElement = xmlDoc.CreateElement("podatki")
        xmlDoc.AppendChild(xmlPodatki)

        Dim xmlParcele As XmlElement = xmlDoc.CreateElement("parcele")
        xmlPodatki.AppendChild(xmlParcele)

        For i As Integer = 1 To n
            Dim xmlParcela As XmlElement = xmlDoc.CreateElement("parcela")
            xmlParcela.SetAttribute("ko", podatki(i, PODATEK_KO))
            xmlParcela.SetAttribute("oznaka", podatki(i, PODATEK_OZNAKA))
            xmlParcele.AppendChild(xmlParcela)

            Dim xmlPovrsina As XmlElement = xmlDoc.CreateElement("povrsina")
            xmlPovrsina.InnerText = podatki(i, PODATEK_POVRSINA)
            xmlParcela.AppendChild(xmlPovrsina)
        Next

        xmlDoc.Save("primer.xml")

        'Dim dat As StreamWriter
        'dat = New StreamWriter("primer.xml")

        'dat.WriteLine("<podatki>")
        'dat.WriteLine("<parcele>")
        'For i As Integer = 1 To n
        '    dat.WriteLine("<parcela ko=""{0}"" oznaka=""{1}"">", podatki(i, PODATEK_KO), podatki(i, PODATEK_OZNAKA))
        '    dat.WriteLine("<povrsina>{0}</povrsina>", podatki(i, PODATEK_POVRSINA))
        '    dat.WriteLine("</parcela>")
        'Next
        'dat.WriteLine("</parcele>")
        'dat.WriteLine("</podatki>")

        'dat.Close()
    End Sub

    Sub IzpisNaZaslon()
        Console.WriteLine()
        Console.WriteLine("----- Izpis parcel")
        Console.WriteLine("KO" & vbTab & "Oznaka" & vbTab & "Površina")
        For i As Integer = 1 To n
            Console.WriteLine(podatki(i, PODATEK_KO) & vbTab & podatki(i, PODATEK_OZNAKA) & vbTab & podatki(i, PODATEK_POVRSINA))
        Next

        Console.WriteLine()
        Console.WriteLine("----- Izpis skupne površine parcel")
        Console.WriteLine("Površina parcel: {0}", povrsina)
    End Sub
End Module
